unit CPExeChild;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ActnList, StdActns, ImgList, PluginClass, ExtCtrls;

type
  TFormChild = class(TForm)
    MainMenu: TMainMenu;
    BigMenuFile: TMenuItem;
    MenuNew: TMenuItem;
    MenuSep1: TMenuItem;
    MenuExit: TMenuItem;
    Images: TImageList;
    Actions: TActionList;
    ActionNew: TFileOpen;
    ActionExit: TAction;
    TimerLoadPlugin: TTimer;
    procedure FormDestroy(Sender: TObject);
    procedure LoadPlugin(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations prives }
    Plugin : TPlugin;
  public
    { Dclarations publiques }
    constructor CreateChild(AOwner : TComponent; FileName : TFileName);
  end;

var
  FormChild: TFormChild;

procedure CreateNewChild(FileName : TFileName);

implementation

uses
  CPExeMain;

{$R *.dfm}

procedure CreateNewChild(FileName : TFileName);
begin
  TFormChild.CreateChild(Application, FileName);
end;

constructor TFormChild.CreateChild(AOwner : TComponent; FileName : TFileName);
begin
  Plugin := TPlugin.Create(FileName);
  Create(AOwner);
  ActionNew.OnAccept := FormMain.ActionNewExecute;
  ActionExit.OnExecute := FormMain.ActionExitExecute;
end;

procedure TFormChild.FormDestroy(Sender: TObject);
begin
  Plugin.Free;
end;

procedure TFormChild.LoadPlugin(Sender: TObject);
begin
  TimerLoadPlugin.Enabled := False;
  Plugin.Load(Self, Images, MainMenu.Items, 0);
  ClientWidth := Plugin.Width;
  ClientHeight := Plugin.Height;
  if Plugin.CanResize then
  begin
    with Constraints do
    begin
      MinWidth := Plugin.MinWidth;
      MaxWidth := Plugin.MaxWidth;
      MinHeight := Plugin.MinHeight;
      MaxHeight := Plugin.MaxHeight;
    end;
    {BorderStyle := bsSizeable;
    if Plugin.CanMaximize then
      BorderIcons := [biSystemMenu, biMaximize]
    else
      BorderIcons := [biSystemMenu];}
  end else
  begin
    with Constraints do
    begin
      MinWidth := 0;
      MaxWidth := 0;
      MinHeight := 0;
      MaxHeight := 0;
    end;
    {BorderStyle := bsSingle;
    BorderIcons := [biSystemMenu];}
  end;
end;

procedure TFormChild.FormResize(Sender: TObject);
begin
  Plugin.Width := ClientWidth;
  Plugin.Height := ClientHeight;
end;

procedure TFormChild.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := Plugin.CanUnload;
end;

procedure TFormChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  Plugin.UnLoad;
end;

end.
