unit CPPkgMain;

interface

uses
  Classes, Controls, Dialogs, Graphics, ExtCtrls, PluginIntf;

type
  // Composant qui sera effectivement insr dans la fiche
  TMonComposant = class(TPanel)
  private
    function IsCaptionStored : boolean;
  public
    constructor Create(AOwner : TComponent); override;
  published
    property Font stored True;
    property Caption stored IsCaptionStored;
  end;

  // Classe implmentant les interfaces
  TTestPlugin = class(TInterfacedObject, IPlugin, IPluginCommands, IPluginSizeable, IPluginEvents)
  private
    FComponent : TMonComposant;

    procedure TestExecute(Sender : TObject);
  public
    constructor Create;
    destructor Destroy; override;

    // Implmentation de IPlugin
    function GetComponent : TAncetre;

    // Implmentation de IPluginCommands
    procedure EnumCommands(EnumCommandsProc : TEnumCommandsProc);

    // Implmentation de IPluginSizeable
    function GetMinWidth : integer;
    function GetMaxWidth : integer;
    function GetMinHeight : integer;
    function GetMaxHeight : integer;
    function GetCanMaximize : boolean;

    // Implmentation de IPluginEvents
    procedure QueryUnload(var CanUnload : boolean);
  end;

function CreatePlugin : IPlugin; stdcall;

exports CreatePlugin;

implementation

function CreatePlugin : IPlugin;
begin
  Result := TTestPlugin.Create;
end;

constructor TMonComposant.Create(AOwner : TComponent);
begin
  inherited;
  Caption := 'Panel cr dans le plug-in';
  with Font do
  begin
    Name := 'Times New Roman';
    Color := clBlue;
    Size := 24;
  end;
  Width := 500;
  Height := 200;
end;

function TMonComposant.IsCaptionStored : boolean;
begin
  Result := Caption <> 'Panel cr dans le plug-in';
end;

constructor TTestPlugin.Create;
begin
  inherited;
  FComponent := TMonComposant.Create(nil);
end;

destructor TTestPlugin.Destroy;
begin
  FComponent.Free;
  inherited;
end;

procedure TTestPlugin.TestExecute(Sender : TObject);
begin
  ShowMessage('Test d''vnement');
end;

function TTestPlugin.GetComponent : TAncetre;
begin
  Result := FComponent;
end;

procedure TTestPlugin.EnumCommands(EnumCommandsProc : TEnumCommandsProc);
begin
  EnumCommandsProc(ComType_BigMenu, 'Test', 'Test de menu principal', 0, nil, nil);
  EnumCommandsProc(ComType_Menu, 'Test', 'Test de menu', 0, nil, TestExecute);
end;

function TTestPlugin.GetMinWidth : integer;
begin
  Result := 300;
end;

function TTestPlugin.GetMaxWidth : integer;
begin
  Result := 0;
end;

function TTestPlugin.GetMinHeight : integer;
begin
  Result := 200;
end;

function TTestPlugin.GetMaxHeight : integer;
begin
  Result := 0;
end;

function TTestPlugin.GetCanMaximize : boolean;
begin
  Result := True;
end;

procedure TTestPlugin.QueryUnload(var CanUnload : boolean);
begin
  CanUnload := MessageDlg('Voulez-vous vraiment dcharger ce plug-in ?',
                          mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;

end.
